import { openBlock as r, createElementBlock as u, normalizeClass as p, createElementVNode as s, normalizeStyle as v, resolveComponent as f, createCommentVNode as m, renderSlot as _, createVNode as S, createBlock as a, toDisplayString as y, withModifiers as w } from "vue";
const k = {
  props: {
    src: {
      type: String,
      default: null
    },
    srcType: {
      type: String,
      default: null
    },
    preload: {
      type: String,
      default: "metadata"
    },
    autoplay: {
      type: Boolean,
      default: !1
    },
    crossorigin: {
      type: String,
      default: null
    },
    loop: {
      type: Boolean,
      default: !1
    },
    muted: {
      type: Boolean,
      default: !1
    }
  },
  data() {
    return {
      loading: !1,
      playing: !1,
      paused: !1,
      seeking: !1,
      ended: !1,
      _muted: this.muted,
      firstPlay: !1,
      duration: null,
      current: 0
    };
  },
  computed: {
    isInProgress() {
      return this.loading || this.seeking;
    }
  },
  watch: {
    loading(e) {
      this.$emit("loading", e);
    },
    playing(e) {
      this.$emit("playing", e);
    },
    paused(e) {
      this.$emit("paused", e);
    },
    current(e) {
      this.$emit("current", e);
    },
    duration(e) {
      this.$emit("duration", e);
    },
    _muted(e) {
      this.$emit("muted", e);
    },
    seeking(e) {
      this.$emit("seeking", e);
    },
    ended(e) {
      this.$emit("ended", e);
    }
  },
  mounted() {
    const e = this.$refs.media;
    e.controls = !1, e.addEventListener("volumechange", this.onVolumeChange), e.addEventListener("loadstart", this.onLoadStart), e.addEventListener("onwaiting", this.onWaiting), e.addEventListener("seeking", this.onSeeking), e.addEventListener("seeked", this.onSeeked), e.addEventListener("ended", this.onEnded), e.addEventListener("suspend", this.onSuspended), e.addEventListener("playing", this.onPlaying), e.addEventListener("pause", this.onPause), e.addEventListener("abort", this.onAbort), e.addEventListener("durationchange", this.onDurationChange), e.addEventListener("progress", this.onProgress), e.addEventListener("timeupdate", this.onTimeUpdate), this.preload === "auto" && this.load();
  },
  beforeDestroy() {
    const e = this.$refs.media;
    e.removeEventListener("volumechange", this.onVolumeChange), e.removeEventListener("loadstart", this.onLoadStart), e.removeEventListener("onwaiting", this.onWaiting), e.removeEventListener("seeking", this.onSeeking), e.removeEventListener("seeked", this.onSeeked), e.removeEventListener("ended", this.onEnded), e.removeEventListener("suspend", this.onSuspended), e.removeEventListener("stalled", this.onStalled), e.removeEventListener("playing", this.onPlaying), e.removeEventListener("pause", this.onPause), e.removeEventListener("abort", this.onAbort), e.removeEventListener("durationchange", this.onDurationChange), e.removeEventListener("progress", this.onProgress), e.removeEventListener("timeupdate", this.onTimeUpdate);
  },
  methods: {
    onVolumeChange() {
      this.$emit("volume", this.$refs.media.volume);
    },
    onLoadStart() {
      this.loading = !0;
    },
    onWaiting() {
      this.loading = !0;
    },
    onSeeking() {
      this.seeking = !0;
    },
    onSeeked() {
      this.$refs.media.readyState === 4 && (this.loading = !1), this.current = this.$refs.media.currentTime, this.seeking = !1;
    },
    onEnded() {
      this.ended = !0;
    },
    onSuspended() {
      this.loading = !1;
    },
    onStalled() {
      this.loading = !0, this.pause = !0;
    },
    onPlaying() {
      this.playing = !0, this.paused = !1, this.ended = !1, this.current = this.$refs.media.currentTime, this.$refs.media.readyState === 4 && (this.loading = !1), this.firstPlay || (this.firstPlay = !0);
    },
    onPause() {
      this.playing = !1, this.paused = !0, this.current = this.$refs.media.currentTime;
    },
    onAbort() {
      this.loading = !1;
    },
    onDurationChange() {
      this.duration = this.$refs.media.duration;
    },
    onProgress() {
      this.current = this.$refs.media.currentTime;
    },
    onTimeUpdate() {
      this.current = this.$refs.media.currentTime;
    },
    mute() {
      this.$refs.media.muted = !0, this._muted = !0;
    },
    unmute() {
      this.$refs.media.muted = !1, this._muted = !1;
    },
    play() {
      this.$refs.media.play();
    },
    pause() {
      this.$refs.media.pause();
    },
    togglePlay() {
      this.ended && this.seek(0), this.playing ? this.pause() : this.play();
    },
    toggleMute() {
      this._muted ? this.unmute() : this.mute();
    },
    seek(e) {
      this.$refs.media.currentTime = e;
    },
    load() {
      this.$refs.media.load(), this.resetFirstPlay();
    },
    unmuteAndTogglePlay() {
      this.firstPlay || (this.unmute(), this.firstPlay = !0), this.togglePlay();
    },
    unmuteOrTogglePlay() {
      !this.firstPlay && (this.muted || this.unmute(), this.firstPlay = !0, this.playing) || this.togglePlay();
    },
    resetFirstPlay() {
      this.firstPlay = !1;
    }
  }
};
const g = (e, n) => {
  const t = e.__vccOpts || e;
  for (const [l, o] of n)
    t[l] = o;
  return t;
}, F = {
  props: {
    value: {
      type: Number,
      default: 0
    },
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 100
    },
    light: {
      type: Boolean,
      default: !1
    },
    loading: {
      type: Boolean,
      default: !1
    }
  },
  data() {
    return {
      percent: 0,
      dragging: !1
    };
  },
  watch: {
    value(e, n) {
      e !== n && (this.percent = (e - this.min) * 100 / (this.max - this.min));
    }
  },
  methods: {
    isScrubber(e) {
      return [e, e.parentNode].includes(this.$refs.scrubber);
    },
    dragStart(e) {
      !this.isScrubber(e.target) || (e.preventDefault(), this.dragging = !0);
    },
    drag(e) {
      !this.dragging || (e.preventDefault(), this.updateProgress(e));
    },
    dragEnd(e) {
      this.dragging && e.stopPropagation(), this.dragging = !1, this.updateProgress(e);
    },
    updateProgress(e) {
      if (!this.isScrubber(e.target) || e.type === "touchend")
        return;
      const n = e.type === "touchmove" ? e.touches[0].clientX : e.clientX, t = this.$refs.scrubber, l = t.clientWidth;
      let o = n - t.getBoundingClientRect().left;
      o >= l && (o = l), o < 0 && (o = 0), this.percent = o * 100 / l, this.$emit("input", this.min + (this.max - this.min) * this.percent / 100), this.$emit("change");
    }
  },
  mounted() {
    window.addEventListener("touchstart", this.dragStart, !1), window.addEventListener("touchend", this.dragEnd, !1), window.addEventListener("touchmove", this.drag, { passive: !1 }), window.addEventListener("mousedown", this.dragStart, !1), window.addEventListener("mousemove", this.drag, !1), window.addEventListener("click", this.dragEnd, { capture: !0 });
  },
  beforeDestroy() {
    window.removeEventListener("touchstart", this.dragStart, !1), window.removeEventListener("touchend", this.dragEnd, !1), window.removeEventListener("touchmove", this.drag, !1), window.removeEventListener("mousedown", this.dragStart, !1), window.removeEventListener("mousemove", this.drag, !1), window.removeEventListener("click", this.dragEnd);
  }
}, M = /* @__PURE__ */ s("div", { class: "bar" }, null, -1);
function z(e, n, t, l, o, i) {
  return r(), u("div", {
    ref: "scrubber",
    class: p({ scrubber: !0, light: t.light, loading: t.loading })
  }, [
    M,
    s("div", {
      class: "progress",
      style: v({ width: o.percent + "%" })
    }, null, 4),
    s("div", {
      class: "handler",
      style: v({ left: o.percent + "%" })
    }, null, 4)
  ], 2);
}
const C = /* @__PURE__ */ g(F, [["render", z]]), W = {
  props: {
    value: {
      type: String,
      required: !0
    },
    size: {
      type: Number,
      default: 24
    }
  },
  computed: {
    styles() {
      return {
        width: this.size + "px",
        height: this.size + "px",
        fontSize: this.size + "px"
      };
    }
  }
}, R = ["d"];
function B(e, n, t, l, o, i) {
  return r(), u("svg", {
    viewBox: "0 0 24 24",
    role: "img",
    "aria-hidden": "true",
    xmlns: "http://www.w3.org/2000/svg",
    style: v(i.styles)
  }, [
    s("path", {
      fill: "currentColor",
      d: t.value
    }, null, 8, R)
  ], 4);
}
const V = /* @__PURE__ */ g(W, [["render", B]]), H = "M8,5.14V19.14L19,12.14L8,5.14Z", $ = "M14,19H18V5H14M6,19H10V5H6V19Z", P = "M12,5V1L7,6L12,11V7A6,6 0 0,1 18,13A6,6 0 0,1 12,19A6,6 0 0,1 6,13H4A8,8 0 0,0 12,21A8,8 0 0,0 20,13A8,8 0 0,0 12,5Z", I = "M12,4L9.91,6.09L12,8.18M4.27,3L3,4.27L7.73,9H3V15H7L12,20V13.27L16.25,17.53C15.58,18.04 14.83,18.46 14,18.7V20.77C15.38,20.45 16.63,19.82 17.68,18.96L19.73,21L21,19.73L12,10.73M19,12C19,12.94 18.8,13.82 18.46,14.64L19.97,16.15C20.62,14.91 21,13.5 21,12C21,7.72 18,4.14 14,3.23V5.29C16.89,6.15 19,8.83 19,12M16.5,12C16.5,10.23 15.5,8.71 14,7.97V10.18L16.45,12.63C16.5,12.43 16.5,12.21 16.5,12Z", T = "M14,3.23V5.29C16.89,6.15 19,8.83 19,12C19,15.17 16.89,17.84 14,18.7V20.77C18,19.86 21,16.28 21,12C21,7.72 18,4.14 14,3.23M16.5,12C16.5,10.23 15.5,8.71 14,7.97V16C15.5,15.29 16.5,13.76 16.5,12M3,9V15H7L12,20V4L7,9H3Z", A = "M5,5H10V7H7V10H5V5M14,5H19V10H17V7H14V5M17,14H19V19H14V17H17V14M10,17V19H5V14H7V17H10Z", O = "M14,14H19V16H16V19H14V14M5,14H10V19H8V16H5V14M8,5H10V10H5V8H8V5M19,8V10H14V5H16V8H19Z";
function E(e, n, t) {
  return (new Array(n || 2).join(t || 0) + (e || t || 0)).slice(-n);
}
function b(e) {
  let n = Math.floor(e / 3600);
  const t = e % (60 * 60);
  let l = Math.floor(t / 60);
  const o = t % 60;
  let i = Math.ceil(o);
  return n = E(n, 2, "0"), l = E(l, 2, "0"), i = E(i, 2, "0"), n === "00" ? [l, i] : [n, l, i];
}
function x(e, n) {
  const t = {};
  return t.height = n.height, t.width = t.height * e, t.width > n.width && (t.width = n.width, t.height = t.width / e), t.top = n.top + (n.height / 2 - t.height / 2), t.left = n.left + (n.width / 2 - t.width / 2), t;
}
const D = {
  name: "AudioPlayer",
  mixins: [k],
  components: {
    Icon: V,
    Scrubber: C
  },
  props: {
    light: {
      type: Boolean,
      default: !1
    },
    playIcon: {
      type: String,
      default: H
    },
    pauseIcon: {
      type: String,
      default: $
    },
    replayIcon: {
      type: String,
      default: P
    },
    volumeOffIcon: {
      type: String,
      default: I
    },
    volumeOnIcon: {
      type: String,
      default: T
    }
  },
  data() {
    return {
      controlbar: !1
    };
  },
  computed: {
    durationTime() {
      return b(this.duration).join(":");
    },
    currentTime() {
      return b(this.current).join(":");
    },
    classes() {
      return {
        "vuemdplayer audio": !0,
        light: this.light
      };
    }
  }
}, N = { class: "player" }, q = ["preload", "loop", "muted", "autoplay", "crossorigin"], Z = ["src", "type"], j = { class: "control-bar visible" }, U = { class: "layout" }, X = /* @__PURE__ */ s("div", { class: "spacer" }, null, -1), G = { class: "flex times" }, J = ["textContent"], K = /* @__PURE__ */ s("span", null, "\xA0/\xA0", -1), Q = ["textContent"];
function Y(e, n, t, l, o, i) {
  const L = f("scrubber"), c = f("icon");
  return r(), u("div", {
    class: p(i.classes)
  }, [
    s("div", N, [
      s("audio", {
        ref: "media",
        preload: e.preload,
        loop: e.loop,
        muted: e.muted,
        autoplay: e.autoplay,
        crossorigin: e.crossorigin
      }, [
        e.src ? (r(), u("source", {
          key: 0,
          src: e.src,
          type: e.srcType
        }, null, 8, Z)) : m("", !0),
        _(e.$slots, "default")
      ], 8, q)
    ]),
    s("div", j, [
      S(L, {
        value: e.current,
        min: 0,
        max: e.duration,
        onInput: e.seek,
        loading: e.isInProgress
      }, null, 8, ["value", "max", "onInput", "loading"]),
      s("div", U, [
        s("button", {
          class: "player-btn",
          icon: "",
          large: "",
          onClick: n[0] || (n[0] = (d) => e.unmuteAndTogglePlay())
        }, [
          e.playing ? (r(), a(c, {
            key: 0,
            value: t.pauseIcon
          }, null, 8, ["value"])) : e.ended ? (r(), a(c, {
            key: 1,
            value: t.replayIcon
          }, null, 8, ["value"])) : (r(), a(c, {
            key: 2,
            value: t.playIcon
          }, null, 8, ["value"]))
        ]),
        X,
        s("div", G, [
          s("span", {
            textContent: y(i.currentTime)
          }, null, 8, J),
          K,
          s("span", {
            textContent: y(i.durationTime)
          }, null, 8, Q)
        ])
      ])
    ])
  ], 2);
}
const Le = /* @__PURE__ */ g(D, [["render", Y]]);
const ee = {}, te = { class: "loader" }, ne = /* @__PURE__ */ s("svg", {
  class: "circular",
  viewBox: "25 25 50 50"
}, [
  /* @__PURE__ */ s("circle", {
    class: "path",
    cx: "50",
    cy: "50",
    r: "20",
    fill: "none",
    "stroke-width": "2",
    "stroke-miterlimit": "10"
  })
], -1), se = [
  ne
];
function ie(e, n) {
  return r(), u("div", te, se);
}
const re = /* @__PURE__ */ g(ee, [["render", ie]]), oe = {
  name: "VideoPlayer",
  mixins: [k],
  props: {
    width: {
      type: Number,
      default: null
    },
    height: {
      type: Number,
      default: null
    },
    doubleClickFullscreen: {
      type: Boolean,
      default: !1
    },
    contain: {
      type: Boolean,
      default: !1
    },
    poster: {
      type: String,
      default: null
    },
    playsinline: {
      type: Boolean,
      default: !1
    },
    contain: {
      type: Boolean,
      default: !1
    },
    playIcon: {
      type: String,
      default: H
    },
    pauseIcon: {
      type: String,
      default: $
    },
    replayIcon: {
      type: String,
      default: P
    },
    volumeOffIcon: {
      type: String,
      default: I
    },
    volumeOnIcon: {
      type: String,
      default: T
    },
    fullscreenIcon: {
      type: String,
      default: A
    },
    fullscreenExitIcon: {
      type: String,
      default: O
    }
  },
  components: {
    Icon: V,
    Preloader: re,
    Scrubber: C
  },
  data() {
    return {
      fullscreen: !1,
      controlbar: !1,
      videoWidth: 0,
      videoHeight: 0,
      containerWidth: 0,
      containerHeight: 0
    };
  },
  computed: {
    classes() {
      return {
        "vuemdplayer video": !0,
        fullscreen: this.fullscreen,
        contain: this.fullscreen || this.contain,
        "has-poster": !!this.poster,
        "first-play": !!this.firstPlay
      };
    },
    styles() {
      let e = 0, n = 0, t = 0, l = 0;
      if (this.containerWidth && this.videoWidth) {
        const o = this.videoWidth / this.videoHeight, i = x(o, { top: 0, left: 0, width: this.containerWidth, height: this.containerHeight });
        e = i.left, n = i.top, t = i.width, l = i.height;
      }
      return {
        "--layer-top": n + "px",
        "--layer-left": e + "px",
        "--layer-width": t + "px",
        "--layer-height": l + "px",
        "--poster": 'url("' + this.poster + '")'
      };
    },
    durationTime() {
      return b(this.duration).join(":");
    },
    currentTime() {
      return b(this.current).join(":");
    }
  },
  mounted() {
    window.addEventListener("resize", this.onWindowResize), this.onResize(), document.addEventListener("fullscreenchange", this.onFullscreenChange), document.addEventListener("webkitfullscreenchange", this.onFullscreenChange);
  },
  beforeDestroy() {
    document.removeEventListener("fullscreenchange", this.onFullscreenChange), document.removeEventListener("webkitfullscreenchange", this.onFullscreenChange), window.removeEventListener("resize", this.onWindowResize);
  },
  methods: {
    onWindowResize() {
      clearTimeout(this._resizeRimer), this._resizeRimer = setTimeout(this.onResize, 500);
    },
    onFullscreenChange(e) {
      this.fullscreen = !!document.fullscreenElement, setTimeout(this.onResize, 0);
    },
    onResize() {
      const e = this.$el;
      !e || (this.containerWidth = e.clientWidth, this.containerHeight = e.clientHeight);
    },
    onLoadedMetadata() {
      const e = this.$refs.media;
      !e || (this.videoWidth = e.videoWidth, this.videoHeight = e.videoHeight);
    },
    onMouseHover() {
      this.controlbar = !0, window.clearTimeout(this.__controlbarTimeout), this.__controlbarTimeout = window.setTimeout(() => {
        this.controlbar = !1;
      }, 3e3);
    },
    exitFullScreen() {
      document.exitFullscreen ? document.exitFullscreen() : document.mozCancelFullScreen ? document.mozCancelFullScreen() : document.webkitExitFullscreen ? document.webkitExitFullscreen() : document.msExitFullscreen && document.msExitFullscreen(), this.fullscreen = !1, setTimeout(this.onResize, 0);
    },
    enterFullScreen() {
      const e = this.$el;
      e.requestFullscreen ? e.requestFullscreen() : e.mozRequestFullScreen ? e.mozRequestFullScreen() : e.webkitRequestFullscreen ? e.webkitRequestFullscreen() : e.msRequestFullscreen && e.msRequestFullscreen(), this.fullscreen = !0, setTimeout(this.onResize, 0);
    },
    toggleFullScreen() {
      this.fullscreen ? this.exitFullScreen() : this.enterFullScreen();
    }
  }
}, le = { class: "player" }, ae = ["width", "height", "preload", "loop", "muted", "autoplay", "crossorigin", "playsinline"], ue = ["src", "type"], de = {
  key: 0,
  class: "overlay"
}, he = {
  key: 1,
  class: "overlay poster"
}, ce = { class: "layout" }, me = /* @__PURE__ */ s("div", { class: "spacer" }, null, -1), fe = { class: "flex times" }, ge = ["textContent"], pe = /* @__PURE__ */ s("span", null, "\xA0/\xA0", -1), ve = ["textContent"];
function ye(e, n, t, l, o, i) {
  const L = f("preloader"), c = f("scrubber"), d = f("icon");
  return r(), u("div", {
    onMouseover: n[5] || (n[5] = (...h) => i.onMouseHover && i.onMouseHover(...h)),
    onDblclick: n[6] || (n[6] = w(() => t.doubleClickFullscreen ? i.toggleFullScreen() : null, ["prevent"])),
    onClick: n[7] || (n[7] = w((...h) => e.unmuteOrTogglePlay && e.unmuteOrTogglePlay(...h), ["prevent"])),
    class: p(i.classes),
    style: v(i.styles)
  }, [
    s("div", le, [
      s("video", {
        ref: "media",
        width: t.width,
        height: t.height,
        preload: e.preload,
        loop: e.loop,
        muted: e.muted,
        autoplay: e.autoplay,
        crossorigin: e.crossorigin,
        playsinline: t.playsinline,
        onLoadedmetadata: n[0] || (n[0] = (...h) => i.onLoadedMetadata && i.onLoadedMetadata(...h))
      }, [
        e.src ? (r(), u("source", {
          key: 0,
          src: e.src,
          type: e.srcType
        }, null, 8, ue)) : m("", !0),
        _(e.$slots, "default")
      ], 40, ae)
    ]),
    e.$slots.overlay ? (r(), u("div", de, [
      _(e.$slots, "overlay")
    ])) : m("", !0),
    t.poster ? (r(), u("div", he)) : m("", !0),
    e.isInProgress ? (r(), a(L, { key: 2 })) : m("", !0),
    s("div", {
      class: p({ "control-bar": !0, visible: o.controlbar || e.paused }),
      onClick: n[4] || (n[4] = w(() => {
      }, ["stop"]))
    }, [
      S(c, {
        value: e.current,
        min: 0,
        max: e.duration,
        onInput: e.seek,
        loading: e.isInProgress
      }, null, 8, ["value", "max", "onInput", "loading"]),
      s("div", ce, [
        s("button", {
          class: "player-btn",
          onClick: n[1] || (n[1] = (h) => e.unmuteAndTogglePlay())
        }, [
          e.playing ? (r(), a(d, {
            key: 0,
            value: t.pauseIcon
          }, null, 8, ["value"])) : e.ended ? (r(), a(d, {
            key: 1,
            value: t.replayIcon
          }, null, 8, ["value"])) : (r(), a(d, {
            key: 2,
            value: t.playIcon
          }, null, 8, ["value"]))
        ]),
        me,
        s("div", fe, [
          s("span", {
            textContent: y(i.currentTime)
          }, null, 8, ge),
          pe,
          s("span", {
            textContent: y(i.durationTime)
          }, null, 8, ve)
        ]),
        s("button", {
          class: "player-btn",
          onClick: n[2] || (n[2] = (h) => e.toggleMute())
        }, [
          e._muted ? (r(), a(d, {
            key: 0,
            value: t.volumeOffIcon
          }, null, 8, ["value"])) : (r(), a(d, {
            key: 1,
            value: t.volumeOnIcon
          }, null, 8, ["value"]))
        ]),
        s("button", {
          class: "player-btn",
          onClick: n[3] || (n[3] = (h) => i.toggleFullScreen())
        }, [
          o.fullscreen ? (r(), a(d, {
            key: 0,
            value: t.fullscreenExitIcon
          }, null, 8, ["value"])) : (r(), a(d, {
            key: 1,
            "fullscreen-icon": "",
            value: t.fullscreenIcon
          }, null, 8, ["value"]))
        ])
      ])
    ], 2)
  ], 38);
}
const we = /* @__PURE__ */ g(oe, [["render", ye]]);
export {
  Le as AudioPlayer,
  we as VideoPlayer
};
